<?PHP
class OS_BR{

    private $agent = "";
    private $info = array();

    function __construct(){
        $this->agent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : NULL;
        $this->getBrowser();
        $this->getOS();
    }

    function getBrowser(){
        $browser = array("Navigator"            => "/Navigator(.*)/i",
                         "Firefox"              => "/Firefox(.*)/i",
                         "Internet Explorer"    => "/MSIE(.*)/i",
                         "Internet Explorer"    => "/Iexplore(.*)/i",
                         "Internet Explorer"    => "/Internet Explorer(.*)/i",
                         "Google Chrome"        => "/chrome(.*)/i",
                         "MAXTHON"              => "/MAXTHON(.*)/i",
                         "Opera"                => "/Opera(.*)/i",
                         );
        foreach($browser as $key => $value){
            if(preg_match($value, $this->agent)){
                $this->info = array_merge($this->info,array("Browser" => $key));
                $this->info = array_merge($this->info,array(
                  "Version" => $this->getVersion($key, $value, $this->agent)));
                break;
            }else{
                $this->info = array_merge($this->info,array("Browser" => "UnKnown"));
                $this->info = array_merge($this->info,array("Version" => "UnKnown"));
            }
        }
        return $this->info['Browser'];
    }

    function getOS(){
        $OS = array("iPhone" => "/(iPhone)/i",
		"Windows 3.11" => "/Win16/i",
		"Windows 95" => "/(Windows 95)|(Win95)|(Windows_95)/i", // Use regular expressions as value to identify operating system
		"Windows 98" => "/(Windows 98)|(Win98)/i",
		"Windows 2000" => "/(Windows NT 5.0)|(Windows 2000)/i",
		"Windows XP" => "/(Windows NT 5.1)|(Windows XP)/i",
		"Windows 2003" => "/(Windows NT 5.2)/i",
		"Windows Vista" => "/(Windows NT 6.0)|(Windows Vista)/i",
		"Windows 7" => "/(Windows NT 6.1)|(Windows 7)/i",
		"Windows NT 4.0" => "/(Windows NT 4.0)|(WinNT4.0)|(WinNT)|(Windows NT)/i",
		"Windows ME" => "/Windows ME/i",
		"Open BSD"=>"/OpenBSD/i",
		"Sun OS"=>"/SunOS/i",
		"Linux"=>"/(Linux)|(X11)/i",
		"Safari" => "/(Safari)/i",
		"Macintosh"=>"/(Mac_PowerPC)|(Macintosh)/i",
		"QNX"=>"/QNX/i",
		"BeOS"=>"/BeOS/i",
		"OS/2"=>"/OS/2/i",
		"Search Bot"=>"/(nuhk)|(Googlebot)|(Yammybot)|(Openbot)|(Slurp/cat)|(msnbot)|(ia_archiver)/i",
		            "Windows"   =>   "/Windows/i",
                    "Linux"     =>   "/Linux/i",
                    "Unix"      =>   "/Unix/i",
                    "Mac"       =>   "/Mac/i"
		
	);
					
					
                   

        foreach($OS as $key => $value){
            if(preg_match($value, $this->agent)){
                $this->info = array_merge($this->info,array("Operating System" => $key));
                break;
            }
        }
        return $this->info['Operating System'];
    }

    function getVersion($browser, $search, $string){
        $browser = $this->info['Browser'];
        $version = "";
        $browser = strtolower($browser);
        preg_match_all($search,$string,$match);
        switch($browser){
            case "firefox": $version = str_replace("/","",$match[1][0]);
            break;

            case "internet explorer": $version = substr($match[1][0],0,4);
            break;

            case "opera": $version = str_replace("/","",substr($match[1][0],0,5));
            break;

            case "navigator": $version = substr($match[1][0],1,7);
            break;

            case "maxthon": $version = str_replace(")","",$match[1][0]);
            break;

            case "google chrome": $version = substr($match[1][0],1,10);
        }
        return $version;
    }

    function showInfo($switch){
        $switch = strtolower($switch);
        switch($switch){
            case "browser": return $this->info['Browser'];
            break;

            case "os": return $this->info['Operating System'];
            break;

            case "version": return $this->info['Version'];
            break;

            case "all" : return array($this->info["Version"], $this->info['Operating System'], $this->info['Browser']);
            break;

            default: return "Unkonw";
            break;

        }
    }
}

// using
// create an new instant of OS_BR class
$obj = new OS_BR();
// // if you want to show one by one information then try showInfo() function

// get browser
// echo $obj->showInfo('browser');

// get browser version
// echo $obj->showInfo('version');

// get Operating system
// echo $obj->showInfo('os');

// get all information and it returns an array
//echo "<pre>".print_r($obj->showInfo("all"),true)."</pre>";

?>